'*****************************************************************************
' CSRDEMO.BAS
' By Rich Geldreich 1992
'
' Demonstrates how to use the procedures in CSRBAS.BAS.
'
' CSRDEMO.BAS - main module of demo
' CSRBAS.BAS  - text mode cursor driver
' MOU.BAS     - mouse driver
' CSRASM.ASM  - general routines for cursor and mouse driver
'*****************************************************************************
DEFINT A-Z

'Routines in CSRBAS.BAS
DECLARE SUB rg.change.cursor (newbitmap&(), newmask&())
DECLARE SUB rg.cursor.deinit ()
DECLARE FUNCTION rg.cursor.init ()
DECLARE SUB rg.move.cursor (current.x, current.y, button.1, button.2, update.flag)
DECLARE SUB rg.off.area (x.low, y.low, x.high, y.high)
DECLARE SUB rg.off.cursor ()
DECLARE SUB rg.old.cursor ()

newcursor:
DATA &H00000000,&HFFFCFFFF,&H00020000,&HFFF8FFFF
DATA &H00060000,&HFFF0FFFF,&H000E0000,&HFFE0FFFF
DATA &H001E0000,&HFFC0FFFF,&H003E0000,&HFF80FFFF
DATA &H007E0000,&HFF00FFFF,&H00FE0000,&HFF00FFFF
DATA &H00FE0000,&HFF00FFFF,&H003E0000,&HFF80FFFF
DATA &H00320000,&HFF80FFFF,&H00300000,&HFF80FFFF
DATA &H00600000,&HFF0FFFFF,&H00600000,&HFF0FFFFF
DATA &H00000000,&HFFFFFFFF,&H00000000,&HFFFFFFFF

DIM newcursor&(15), newmask&(15)

PRINT "Smooth Text Mode Cursor Routines for PDS and QuickBASIC 4.5"
PRINT "By Rich Geldreich July, 1992"

'Attempt to initialize the driver.

IF NOT rg.cursor.init THEN
    PRINT "No mouse driver found!"
    END
END IF
PRINT "Hit a key or left mouse button to end. Press right mouse button to change"
PRINT "the cursor's appearance."
RESTORE newcursor
FOR a = 0 TO 15: READ newcursor&(a), newmask&(a): NEXT

PRINT
xpos = POS(0): ypos = CSRLIN - 1

'Main loop.
DO
    'get the mouse's x,y coordinates and button status.
    rg.move.cursor x, y, a, b, -1
    'toggle the cursor's appearance if the right mouse button is
    'pressed
    IF b AND last = 0 THEN
        c = NOT c
        IF c THEN
            rg.change.cursor newcursor&(), newmask&()
        ELSE
            rg.old.cursor
        END IF
    END IF
    last = b

    'did it move?
    IF x <> xlast OR y <> ylast THEN
        'tell the driver we will be updating the screen
        'the driver will turn off the cursor if it's overtop of
        'the area that'll change

        rg.off.area 1, ypos, 20, ypos
        LOCATE ypos, xpos
        PRINT "X: "; MID$(STR$(x), 2); " Y:"; MID$(STR$(y), 2); STRING$(5, 32);
    END IF
    'remember last x,y coordinates
    xlast = x: ylast = y

LOOP UNTIL INKEY$ <> "" OR a

'Deinitialize the driver.
rg.cursor.deinit
END

